'use strict'

const fs = require('fs').promises // we need something to fail asynchronously that can't be optimized away by V8
const grpc = require('grpc')
const loader = require('@grpc/proto-loader')

async function reproAsync(call) {
  const files = await fs.readdir('foo') // should fail asynchronously

  console.log('Shouldn\'t get there')

  return {}
}

function repro(call, callback) {
  reproAsync(call)
    .then(result => {
      console.log('Shouldn\'t get there either')
      callback(null, result)
    })
    .catch(error => {
      console.error(error)
      callback(error)
    })
}

function main() {
  console.log('Starting server')
  const service = grpc.loadPackageDefinition(loader.loadSync('repro.proto', {})).repro.service
  const server = new grpc.Server()
  server.addService(service, {
    repro: repro
  })
  server.bind('0.0.0.0:8080', grpc.ServerCredentials.createInsecure())
  server.start()
}

main()
